'HDLOS a piping head loss program adapted from an original HP-41 probram

'The following are the HP-41 registers for reference to orig prgm only.
'reg00=pipe id
'reg01=gpm
'reg02=pipe roughness e
'reg03=relative roughness e/D
'reg04=water temp F
'reg05=abs viscosity centipoise
'reg06=Reynolds no.
'reg07=1/root(ff) or ff
'reg08=ff(xi)
'reg09=1/root(ff)or ff fully turbulent
'reg10=pipe length ft.
'reg11=sum K/ff
'reg12=sum head loss
'reg13=pump eff n
'reg14=motor eff
'reg15=weight density rho
'reg16=HP
'reg17=equipment hd loss, ft.
'reg18=static head loss, ft
'reg19=sum K

rev$="rev 7-09-02"	'be sure to change rev date below also.
GOSUB help

label12:
ON KEY (10) GOSUB stop_pgm
KEY (10) ON
rev$="rev 7-09-02"
CLS
COLOR 11
PRINT "-------------------- Piping Head Loss and Pumping Power -------------------"
COLOR 12
LOCATE 2,1
PRINT "F10 ^ to exit               by Michael Krabach                  ";rev$
COLOR 11
LOCATE 3,1
PRINT "----------- Input Data ------------   --------------- Output --------------"
COLOR 7
LOCATE 4,1
PRINT SPC(30)
LOCATE 4,1
INPUT "Pipe ID (inches)"; reg00

LOCATE 5,1
PRINT SPC(30)
label05:
LOCATE 5,1
INPUT "Length (feet)"; morereg10
reg10=reg10+morereg10
IF morereg10<>0 THEN
    LOCATE 5,1
    PRINT SPC(30)
    LOCATE 5,25
	PRINT reg10
   	GOTO label05	'get more pipe if input not zero
END IF
LOCATE 5,1
PRINT SPC(30)
LOCATE 5,1
PRINT "Total pipe length=";reg10

label04:
LOCATE 6,1
INPUT "Valve K/ff"; morereg11
reg11=reg11+morereg11
IF morereg11<>0 THEN
    LOCATE 6,1
    PRINT SPC(30)
    LOCATE 6,25
    PRINT reg11
	GOTO label04	'get more pipe fittings
END IF
LOCATE 6,1
PRINT SPC(30)
LOCATE 6,1
PRINT "Total K/ff="; reg11

label07:
LOCATE 7,1
INPUT "specific K="; morereg19
reg19=reg19+morereg19
IF morereg19<>0 THEN
    LOCATE 7,1
    PRINT SPC(30)
    LOCATE 7,25
    PRINT reg19
	GOTO label07	'get more K
END IF
LOCATE 7,1
PRINT SPC(30)
LOCATE 7,1
PRINT "Total specific K ="; reg19

IF add_pipe_flag=1 THEN
    LOCATE 8,1
    INPUT "Same gpm in pipe (y,n)"; ans$
    IF ans$="y" THEN GOTO label20
END IF

LOCATE 8,1
PRINT SPC(22)
LOCATE 8,1
INPUT "Gpm thru pipe";reg01

label20:
INPUT "Equipment head (feet)"; reg17
INPUT "Elevation change (feet)"; reg18


IF add_pipe_flag=1 THEN
	INPUT "Same type of pipe (y,n)"; ans$
    IF ans$="y" THEN GOTO label22
END IF

label21:
LOCATE 11,1
INPUT "Pipe type: comm Steel, drawn Tubing, Other (s,t,o)";ans$
LOCATE 11,1
PRINT SPC(70)
LOCATE 11,1
SELECT CASE ans$
	CASE "s"
    	reg02=.00015
    CASE "t"
    	reg02=.000005
    CASE "o"
		INPUT "Pipe roughness coeff e";  reg02
	CASE ELSE
    	GOTO label21
END SELECT
LOCATE 11,1
PRINT "Pipe roughness coeff e=";reg02

label22:
reg03=(reg02/reg00)*12	'e/D relative roughness of pipe
IF (water_flag=1 OR nonwater_flag=1) THEN GOTO label00

label23:
LOCATE 12,1
INPUT "Is the fluid water (y/n)"; ans$
IF ans$="y" THEN
	GOSUB label_water
    ELSEIF ans$="n" THEN
    GOSUB label_nonwater
    ELSE
    GOTO label23
END IF

label00:

IF add_pipe_flag=1 THEN
    LOCATE 12,1
	INPUT "Same temperature (y,n)"; ans$
    IF ans$="n" THEN
    	IF water_flag=1 THEN GOSUB label_water
    	IF nonwater_flag=1 THEN GOSUB label_nonwater
    END IF
END IF

reg06=50.6*reg01*reg15/(reg00*reg05)	'Reynolds number
LOCATE 4,40
PRINT "Reynolds Number="; reg06
IF reg06<2000 THEN laminar_flag=1
reg09=-.86*LOG(reg03/3.7)	'1/root(tff) for 1st approx for fully turbulent flow
LOCATE 5,40
PRINT "Fully turbulent ff=";(1/reg09)^2

IF laminar_flag=0 THEN
    reg07=reg09		'fully turbulent for 1st approx of transitional flow
    DO
    	reg08=-.86*LOG(reg03/3.7+(reg07*2.51/reg06))
    	chg=ABS((reg08-reg07)/reg08)
    	reg07=reg08
    LOOP UNTIL chg<1
END IF

label03:
LOCATE 6,40
IF laminar_flag=1 THEN
	PRINT "Laminar flow"
    reg07=64/reg06	'use laminar friction factor
    ELSEIF laminar_flag=0 THEN
    PRINT "Turbulent flow"
	reg07=(1/reg07)^2	 'pipe transitional ff
END IF
LOCATE 7,40
PRINT "Pipe friction factor=";reg07
kpipe=12*(reg10*reg07)/reg00	'k for pipe
LOCATE 8,40
PRINT "K piping="; kpipe
kvalve=reg11*(1/reg09)^2  'with fully turbulent flow in fittings
sumk=kvalve+kpipe+reg19
LOCATE 9,40
PRINT "Section K="; sumk
GOSUB velocity
LOCATE 10,40
PRINT "Velocity (ft/sec)="; vel
IF add_pipe_flag=0 THEN reg21=vel	'save the original velocity in starting pipe
hlos=(0.00259*sumk*reg01^2)/reg00^4
LOCATE 11,40
PRINT "Piping head loss (ft)="; hlos
reg12=hlos+reg17+reg18	'for this section of system
totalhd=totalhd+reg12	'store total head loss if system has more than one section
totalelv=totalelv+reg18	'save total static head for new_gpm formula
LOCATE 12,40
PRINT "Section Head Loss (ft)= ";reg12
LOCATE 17,1
INPUT "More pipe (y/n) "; ans$
COLOR 11
LOCATE 18,1
PRINT "---------------------------------------------------------------------------"
COLOR 7
IF ans$="y" THEN
	add_pipe_flag=1
	reg10=0	'reset length
    reg11=0 'reset K/FF
    reg19=0 'reset K
    sumk=0  'reset sum of K
	GOTO label12
END IF

GOSUB velocity
velhd=(vel^2-reg21^2)/64.4
LOCATE 13,40
PRINT "Velocity head (ft)="; velhd
reg12=reg12+velhd
LOCATE 14,40
PRINT "Total head loss (ft)="; totalhd
deltap=totalhd*reg15/144
LOCATE 15,40
PRINT "System delta (psi)=";deltap

LOCATE 19,1
INPUT "Pump efficiency %="; reg13

IF reg13=0 THEN GOTO new_gpm

LOCATE 20,1
INPUT "Electric motor efficiency %="; reg14
reg16=reg01*reg12*reg15/(247000*reg13*reg14)
add_pipe_flag=0
water_flag=0
nonwater_flag=0
LOCATE 19,40
PRINT "Horsepower=";reg16
kw_load=reg16*0.746
LOCATE 20,40
PRINT "Kw load=";kw_load


new_gpm:
COLOR 11
LOCATE 21,1
PRINT "---------------------------------------------------------------------------"
COLOR 7
LOCATE 22,1
PRINT SPC(20)
LOCATE 22,1
INPUT "New gpm (y,n)"; ans$
IF ans$<>"y" THEN
	CLEAR		'clear all variables
	GOTO label12
END IF
LOCATE 23,1
PRINT SPC(20)
LOCATE 23,1
INPUT "gpm"; gpm2
ahlos=(totalhd-totalelv)*gpm2^2/reg01^2
LOCATE 22,40
PRINT "Approx head loss="; ahlos+totalelv
delta=(ahlos+totalelv)*reg15/144
LOCATE 23,40
PRINT "System delta (psi)=";delta
GOTO new_gpm

velocity:
vel=0.408*reg01/reg00^2
return

label_water:
water_flag=1
INPUT "Temperature, F"; reg04
reg05=2.9444e-9*reg04^4-1.8724e-6*reg04^3+4.58346e-4*reg04^2-.054376*reg04+3.11071
reg15=(1.937+1988e-7*reg04-2976e-9*reg04^2)*32.2
PRINT "Viscosity, cPoise="; reg05
PRINT "Weight Density, lb/ft3="; reg15
RETURN

label_nonwater:
nonwater_flag=1
INPUT "Absolute Viscosity (cPoise)"; reg05
INPUT "Density (lb/ft3)"; reg15
RETURN

help:
CLS
COLOR 11
PRINT "-------------------- Piping Head Loss and Pumping Power -------------------"
COLOR 12
LOCATE 2,1
PRINT "F10 ^ to exit               by Michael Krabach                  ";rev$
PRINT
COLOR 7
PRINT "This program is for uncompressible fluid flow in piping sections in series."_
"Parallel or crossover systems will not be solved."
PRINT
PRINT "Reference: FLOW OF FLUIDS through valves, fittings, and pipe by Crane, 1976"_
"edition (english units used). Needed for K/ff and K values and fluid para-"_
"meters other than water. K/ff and K values are from the `K' Factor Table,"_
"Crane pg A-26, 1976 ed.  See pg A-3 and A-7 for viscosity and density for"_
"other fluids than water.  This data may be else where for other editions or"_
"in other data sources."
PRINT
PRINT "Multiple values of length, K/ff and K maybe entered to facilitate entering"_
"multiple items in a piping system.  At any prompt, key in the data, or key"_
"`Enter' (i.e. zero value) to jump to the next prompt. When the 1st diameter"_
"section of piping has been analyzed, you will have the option to continue"_
"with another section of piping. If not needed, you may skip the pumping"_
"power by keying `Enter' at the `Pump Efficiency=?' prompt."
PRINT
PRINT "At the end, the prompt for `New gpm' allows calculating an approximate head"_
"loss for a different gpm without entering all new data.  Keying `n' will"_
"restart the program. F10 `Enter' will terminate the program at any time."_

LOCATE 24,27
COLOR 14
PRINT "Space key to continue"
GOSUB waitabit
RETURN

waitabit:
WHILE NOT INSTAT : WEND
a$=INKEY$
RETURN

stop_pgm:
LOCATE 25,1
END